## bodega-client 0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

add_subdirectory(lib)
add_subdirectory(activeclient)
add_subdirectory(primavera)

=== activeclient/CMakeLists.txt ===
find_package(KDE4 REQUIRED)

include(KDE4Defaults)
include_directories( ${KDE4_INCLUDES} ${QT_INCLUDES} ${CMAKE_SOURCE_DIR}/lib)

add_subdirectory(src)

# QML-only thing
install(DIRECTORY package/ DESTINATION ${DATA_INSTALL_DIR}/plasma/packages/com.makeplaylive.addonsapp)
install(FILES active-addons.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

=== lib/CMakeLists.txt ===
PROJECT(bodega)

set(BODEGA_LIB_MAJOR_VERSION "0")
set(BODEGA_LIB_MINOR_VERSION "1")
set(BODEGA_LIB_PATCH_VERSION "0")

set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII" )

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND cmake_policy)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND cmake_policy)

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules" "${CMAKE_INSTALL_PREFIX}/share/apps/cmake/modules")

set(CMAKE_INSTALL_NAME_DIR ${LIB_INSTALL_DIR})

# compile in debug mode
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

IF("${CMAKE_BUILD_TYPE}" MATCHES "^Rel.*")
  ADD_DEFINITIONS("-DQT_NO_DEBUG_OUTPUT")
  ADD_DEFINITIONS("-DQT_NO_DEBUG_OUTPUT")
ENDIF("${CMAKE_BUILD_TYPE}" MATCHES "^Rel.*")

# Ability to disable verbose debug output
IF(BODEGA_VERBOSE_DEBUG_OUTPUT)
  ADD_DEFINITIONS("-DBODEGA_VERBOSE_DEBUG_OUTPUT")
endif(BODEGA_VERBOSE_DEBUG_OUTPUT)

# Find the dependencies
FIND_PACKAGE( Qt4 COMPONENTS QtCore QtNetwork REQUIRED )
FIND_PACKAGE( QJSON REQUIRED )

#add extra search paths for libraries and includes
SET (LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
SET (LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE STRING "Directory where lib will install")
SET (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "The directory the headers are installed in")
SET (CMAKE_MODULES_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/apps/cmake/modules" CACHE PATH "The directory to install FindQRpc.cmake to")

set(BODEGA_LIB_VERSION_STRING "${BODEGA_LIB_MAJOR_VERSION}.${BODEGA_LIB_MINOR_VERSION}.${BODEGA_LIB_PATCH_VERSION}")

set(LIBRARY_OUTPUT_PATH "${CMAKE_BINARY_DIR}/lib${LIB_SUFFIX}" )

# pkg-config
IF (NOT WIN32)
  CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/bodega.pc.in
                  ${CMAKE_CURRENT_BINARY_DIR}/bodega.pc
                  @ONLY)
  INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/bodega.pc
           DESTINATION lib${LIB_SUFFIX}/pkgconfig)
ENDIF (NOT WIN32)

# Include the cmake file needed to use qt4
INCLUDE( ${QT_USE_FILE} )

# Subdirs
add_subdirectory(bodega)
IF (KDE4_BUILD_TESTS OR BODEGA_BUILD_TESTS)
  enable_testing()
  ADD_SUBDIRECTORY(tests)
ENDIF (KDE4_BUILD_TESTS OR BODEGA_BUILD_TESTS)

add_subdirectory(cmake/modules)


#CONFIGURE_FILE(
#  "${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in"
#  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
#  IMMEDIATE @ONLY)

#ADD_CUSTOM_TARGET(uninstall
#  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== primavera/CMakeLists.txt ===
find_package(KDE4 REQUIRED)

include(KDE4Defaults)

add_subdirectory(src)

# QML-only thing
install(DIRECTORY package/ DESTINATION ${DATA_INSTALL_DIR}/plasma/packages/com.makeplaylive.primavera)
install(FILES vivaldi-primavera.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

=== activeclient/src/CMakeLists.txt ===

include_directories( ${KDE4_INCLUDES} ${QT_INCLUDES} ${BODEGA_INCLUDE_DIR} common)

set(active-addons_SRCS
    main.cpp
    bodegastore.cpp

    common/dataenginebindings.cpp
    common/kdeclarativeview.cpp
    common/kdeclarativemainwindow.cpp
)

KDE4_ADD_EXECUTABLE(active-addons ${active-addons_SRCS})

target_link_libraries(active-addons
    ${QT_QTDECLARATIVE_LIBRARY}
    ${QT_QTOPENGL_LIBRARY}
    ${QT_QTSCRIPT_LIBRARY}
    ${KDE4_PLASMA_LIBS}
    kdeclarative
    bodega
)

install(TARGETS active-addons ${INSTALL_TARGETS_DEFAULT_ARGS} )

=== lib/bodega/CMakeLists.txt ===

set (bodega_HEADERS
     assetjob.h
     assetoperations.h
     collectionaddassetjob.h
     collectionlistassetsjob.h
     collectionlistassetsjobmodel.h
     collectionremoveassetjob.h
     bodegamodel.h
     changelanguagejob.h
     channelsjob.h
     createcollectionjob.h
     deletecollectionjob.h
     error.h
     globals.h
     historymodel.h
     imagelocator.h
     installjob.h
     listcollectionsjob.h
     listcollectionsjobmodel.h
     networkjob.h
     participantinfojob.h
     registerjob.h
     session_p.h
     session.h
     signonjob.h
     uninstalljob.h
    )

set (bodega_SRCS
     assetjob.cpp
     assethandler.cpp
     assethandlerfactory.cpp
     assetoperations.cpp
     collectionaddassetjob.cpp
     collectionlistassetsjob.cpp
     collectionlistassetsjobmodel.cpp
     collectionremoveassetjob.cpp
     bodegamodel.cpp
     changelanguagejob.cpp
     channelsjob.cpp
     createcollectionjob.cpp
     deletecollectionjob.cpp
     error.cpp
     historymodel.cpp
     imagelocator.cpp
     installjob.cpp
     installjobsmodel.cpp
     listcollectionsjob.cpp
     listcollectionsjobmodel.cpp
     networkjob.cpp
     participantinfojob.cpp
     registerjob.cpp
     session.cpp
     signonjob.cpp
     uninstalljob.cpp
     )

include("CMakeQtUsage")

include_directories(${CMAKE_SOURCE_DIR}/lib ${CMAKE_SOURCE_DIR}/lib/bodega ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${QT4_INCLUDES} ${QJSON_INCLUDE_DIRS})

qt4_automoc(${bodega_SRCS})

add_library (bodega SHARED ${bodega_SRCS})
target_link_libraries(bodega  ${QT_LIBRARIES} ${QJSON_LIBRARIES})


set_target_properties(bodega PROPERTIES
                      VERSION ${BODEGA_LIB_MAJOR_VERSION}.${BODEGA_LIB_MINOR_VERSION}.${BODEGA_LIB_PATCH_VERSION}
                      SOVERSION ${BODEGA_LIB_MAJOR_VERSION}
                      DEFINE_SYMBOL BODEGA_MAKEDLL
                      )

INSTALL(TARGETS bodega
   LIBRARY DESTINATION ${LIB_INSTALL_DIR}
   RUNTIME DESTINATION bin
   ARCHIVE DESTINATION  ${LIB_INSTALL_DIR}
)

install(FILES
        ${bodega_HEADERS}
        DESTINATION ${INCLUDE_INSTALL_DIR}/bodega COMPONENT Devel
)


add_subdirectory(handlers)

=== lib/tests/CMakeLists.txt ===
ADD_SUBDIRECTORY(connection)
ADD_SUBDIRECTORY(jobs)
ADD_SUBDIRECTORY(model)

=== primavera/src/CMakeLists.txt ===
include_directories(${KDE4_INCLUDES} ${QT_INCLUDES} ${CMAKE_SOURCE_DIR}/activeclient/src/common)

set(primavera_SRCS
    main.cpp
    ${CMAKE_SOURCE_DIR}/activeclient/src/common/dataenginebindings.cpp
    ${CMAKE_SOURCE_DIR}/activeclient/src/common/kdeclarativeview.cpp
    ${CMAKE_SOURCE_DIR}/activeclient/src/common/kdeclarativemainwindow.cpp
)

KDE4_ADD_EXECUTABLE(primavera ${primavera_SRCS})

target_link_libraries(primavera
    ${QT_QTDECLARATIVE_LIBRARY}
    ${QT_QTOPENGL_LIBRARY}
    ${QT_QTSCRIPT_LIBRARY}
    ${KDE4_PLASMA_LIBS}
    kdeclarative
)

install(TARGETS primavera ${INSTALL_TARGETS_DEFAULT_ARGS} )

=== lib/bodega/handlers/CMakeLists.txt ===
find_package(PackageKitQt2)
if (PACKAGEKIT_QT2_FOUND)
   add_subdirectory(rpm)
else (PACKAGEKIT_QT2_FOUND)
   message("Did not find pkgqt2, required for RPM installation handler")
endif (PACKAGEKIT_QT2_FOUND)

add_subdirectory(epub)
add_subdirectory(package)
add_subdirectory(wallpaper)

=== lib/cmake/modules/CMakeLists.txt ===
set(cmakeFiles FindBODEGA.cmake)
install(FILES ${cmakeFiles} DESTINATION ${CMAKE_MODULES_INSTALL_DIR})

=== lib/tests/connection/CMakeLists.txt ===
# Use it
INCLUDE( ${QT_USE_FILE} )

INCLUDE(AddFileDependencies)

include_directories(${CMAKE_SOURCE_DIR}/lib)

link_directories(${LINK_DIRECTORIES} ${qjson_LIBRARY_DIRS})

# Include the library include directories, and the current build directory (moc)
INCLUDE_DIRECTORIES(
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/libs/bodega
  ${CMAKE_CURRENT_BINARY_DIR}
  ${qjson_INCLUDE_DIR}
  ${CMAKE_INSTALL_PREFIX}/include
)
qt4_wrap_cpp(tester_MOC_SRCS tester.h)

ADD_EXECUTABLE(
  connection
  main.cpp
  tester.cpp
  ${tester_MOC_SRCS}
)

TARGET_LINK_LIBRARIES(
  connection
  ${QT_LIBRARIES}
  ${qjson_LIBRARIES}
  bodega
)

=== lib/tests/jobs/CMakeLists.txt ===
SET( QT_USE_QTTEST TRUE )

# Use it
INCLUDE( ${QT_USE_FILE} )

INCLUDE(AddFileDependencies)

# Include the library include directories, and the current build directory (moc)
INCLUDE_DIRECTORIES(
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/lib/
  ${CMAKE_CURRENT_BINARY_DIR}
)
link_directories(${LINK_DIRECTORIES} ${qjson_LIBRARY_DIRS})

add_definitions(-DSOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}")
set(tst_jobs_SRCS
    dummyserver.cpp
    tst_jobs.cpp)

ADD_EXECUTABLE(
  tst_jobs
  ${tst_jobs_SRCS}
)
qt4_automoc(${tst_jobs_SRCS})

TARGET_LINK_LIBRARIES(
  tst_jobs
  ${QT_LIBRARIES}
  ${qjson_LIBRARIES}
  bodega
)

add_test( tst_jobs tst_jobs )

=== debian/changelog ===
bodega-client (0.2-0ubuntu4) utopic; urgency=medium

  * Remove build-dep on nepomuk

 -- Jonathan Riddell <jriddell@ubuntu.com>  Tue, 12 Aug 2014 17:13:41 +0200

bodega-client (0.2-0ubuntu3) trusty; urgency=medium

  * Make libbodega-dev depend on libbodega0

 -- Harald Sitter <apachelogger@kubuntu.org>  Fri, 21 Feb 2014 10:42:36 +0100

bodega-client (0.2-0ubuntu2) trusty; urgency=medium

  * Add patch kubuntu_install-cmake-module.diff to fix cmake module install dir
  * Put cmake module into libbodega-dev

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 20 Feb 2014 23:23:06 +0000

bodega-client (0.2-0ubuntu1) saucy; urgency=low

  * Initial release LP: #1227602
  * Add build-dep on libqt4-opengl-dev

 -- Jonathan Riddell <jriddell@ubuntu.com>  Tue, 17 Sep 2013 12:24:44 +0100

=== debian/control ===
Source: bodega-client
Section: kde
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Jonathan Riddell <jriddell@ubuntu.com>
Build-Depends: debhelper (>= 8.0.0), cmake, pkg-kde-tools, libqjson-dev, kdelibs5-dev, libqt4-opengl-dev
Standards-Version: 3.9.4
Homepage: http://plasma-active.org/

Package: bodega-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Make Play Live content store applet
 Client applications for the Make Play Live content store.

Package: libbodega0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libs
Description: Make Play Live content store library
 Library for the Make Play Live content store.

Package: libbodega-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libbodega0 (= ${binary:Version})
Section: libdevel
Description: Make Play Live content store library
 Library for the Make Play Live content store.
 .
 Development files.
